/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.sanskritlibrary.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.sanskritlibrary.webservice.UniversalProxy;
import org.sanskritlibrary.webservice.ByteBuffer;
import java.util.Enumeration;
import java.util.Hashtable;
import javax.servlet.ServletInputStream;

/**
 *
 * @author rbunker
 */
public class UniversalProxyServlet extends HttpServlet
{

	/**
	 * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
	 * @param request servlet request
	 * @param response servlet response
	 * @throws ServletException if a servlet-specific error occurs
	 * @throws IOException if an I/O error occurs
	 */
	protected void processRequest(String method, HttpServletRequest request, HttpServletResponse response)
			  throws ServletException, IOException
	{
		boolean debug = true;
		
		response.setContentType("text/html;charset=UTF-8");
		//PrintWriter out = response.getWriter();
		ServletOutputStream out = response.getOutputStream();
		try
		{
			int contentLength = 0;
			Hashtable<String, String> headers = new Hashtable<String, String>();
			Enumeration<String> en = request.getHeaderNames();
			while (en.hasMoreElements())
			{
				String name = en.nextElement();
				String value = request.getHeader(name);
				if (name.toLowerCase().equals("content-type"))
					value = value.substring(2);
				else if (name.toLowerCase().equals("content-length"))
					contentLength = Integer.parseInt(value);
				headers.put(name, value);
			}

			UniversalProxy proxy = new UniversalProxy();
			byte[] data = null;

			String url = request.getParameter("url");

			if (contentLength > 0)
			{
				ServletInputStream sis = request.getInputStream();
				data = new byte[contentLength];
				sis.read(data, 0, data.length);
			}

			if (proxy.getResponse(method, url, headers, data))
			{
				int status = proxy.getStatus();
				response.setStatus(status);
				Hashtable<String, String> h = proxy.getHeaders();
				en = h.keys();
				while (en.hasMoreElements())
				{
					String name = en.nextElement();
					String value = h.get(name);
					response.setHeader(name, value);
				}
				try
				{
					ByteBuffer bb = proxy.getContent();
					response.setContentLength(bb.len);
					//String debug = new String(bb.content, 0, bb.len);
					out.write(bb.content, 0, bb.len);
					//out.print(new String(proxy.getContent()));
				}
				catch (Exception ex)
				{
					out.print(ex.getMessage());
				}
			}
			else
				out.print(proxy.getError());
		}
		catch (Exception ex)
		{
			out.print(ex.getMessage());
		}
		finally
		{
			if (out != null)
			{
				out.flush();
				out.close();
			}
		}
	}

	@Override
	protected void doGet(HttpServletRequest request, HttpServletResponse response)
			  throws ServletException, IOException
	{
			processRequest("GET", request, response);
	}

	@Override
	protected void doPost(HttpServletRequest request, HttpServletResponse response)
			  throws ServletException, IOException
	{
		processRequest("POST", request, response);
	}

	/**
	 * Returns a short description of the servlet.
	 * @return a String containing servlet description
	 */
	@Override
	public String getServletInfo()
	{
		return "Short description";
	}// </editor-fold>
}
