package org.sanskritlibrary.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.Cookie;
import javax.servlet.ServletInputStream;
import java.util.Enumeration;
import javax.servlet.RequestDispatcher;

public class UniversalProxyTester extends SanskritLibraryServlet {
   
    protected void processRequest(String method, HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
	 {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try 
		  {
			  out.print("<h1>Summary</h1>");

			  out.format("<h2>Method</h2>\n%s\n", method);
			  out.print("<h2>Headers:</h2>");
			  Enumeration en = request.getHeaderNames();
			  while (en.hasMoreElements())
			  {
				  String name = (String)en.nextElement();
				  String value = request.getHeader(name);
				  out.format("%s: %s<br/>", name, value);
			  }
			  out.print("<h2>Query Parameters</h2>");
			  String queryString = request.getQueryString();
			  if (queryString != null && !queryString.equals("null"))
				out.format("%s<br/>", queryString);
			  else
				out.print("No query parameters<br/>");

			  String content = "";
			  if (request.getContentType()!= null)
			  {
					if (!request.getContentType().startsWith("application/x-www-form-urlencoded"))
					{
						int contentLength = request.getContentLength();
						if (contentLength > 0)
						{
							byte[] b = new byte[contentLength];
							ServletInputStream in = request.getInputStream();
							in.read(b);
							in.close();
							content = new String(b, 0, b.length, "UTF-8");
						}
						else
							content = "No content";
					}
					else
						content = "Content parsed by Tomcat to get form parameters";
			  }
			  else
				  content = "N/A";

			  out.format("<h2>Content</h2>\n%s\n", content);

			  out.format("<h2>Parameters as returned by getParameter()</h2>");
			  en = request.getParameterNames();
			  while (en.hasMoreElements())
			  {
				  String name = (String)en.nextElement();
				  String value = request.getParameter(name);
				  out.format("%s=%s<br/>", name, value);
			  }

			  out.print("<h2>Cookies</h2>");
			  for (Cookie cookie :request.getCookies())
			  {
				  String name = cookie.getName();
				  String value = cookie.getValue();
				  out.format("%s: %s<br/>", name, value);
				  value += "!";
				  response.addCookie(new Cookie(name, value));
			  }
			  out.print("The values of all the above cookies should be returned in the custom header X-Set-Proxy-Cookie with a ! appended to them.<br/>");
        } 
		  finally
		  {
            out.close();
        }
    } 

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
	 {
		if (request.getParameterMap().size() == 0)
		{
			RequestDispatcher rd = request.getRequestDispatcher("UniversalProxyTester.jsp");
			rd.forward(request, response);
		}
		else
        processRequest("GET", request, response);
    } 

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException
	 {
        processRequest("POST", request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
